
#ifndef __STTRANSFORM_H__
#define __STTRANSFORM_H__


/**
* STTransform represents a transform.  The transform is represented
* as a 4x4 matrix.
*/
class STTransform {

	public:

		STTransform();
		STTransform(const float _m[4][4]);
		STTransform(const float _m00, const float _m01, const float _m02, const float _m03,
					const float _m10, const float _m11, const float _m12, const float _m13,
					const float _m20, const float _m21, const float _m22, const float _m23,
					const float _m30, const float _m31, const float _m32, const float _m33);
		STTransform(const STTransform& xform);

		float* GetGLMatrix();

		STTransform operator*(const STTransform& rhs);

		static STTransform Rotate(float theta, float x, float y, float z);
		static STTransform Translate(float xtrans, float ytrans, float ztrans);
		static STTransform Scale(float xscale, float yscale, float zscale);
	private:

		float		m[4][4];
};


#endif  // __STTRANSFORM_H__

