
#ifndef __STVECTOR_H__
#define __STVECTOR_H__


/**
*  Simple class to represent 3D points
*  Note: ***not used elsewhere by libST at the moment***
*     (added as a convenience class for CS148 Assignment 8)
*/
class STPoint3D {
	public:
		float x, y, z;
		STPoint3D() :
			x(0.0f), y(0.0f), z(0.0f) { }
		STPoint3D(float px, float py, float pz)
			: x(px), y(py), z(pz) { }
};


class STVector {
	public:

		float x, y, z;

		STVector() :
			x(0.0f), y(0.0f), z(0.0f) { }

		STVector(const STPoint3D& p) :
			x(p.x), y(p.y), z(p.z) { }

		STVector(const STVector& v) :
			x(v.x), y(v.y), z(v.z) { }

		STVector operator+(const STVector& rhs) const;
		STVector& operator+=(const STVector& rhs);
		STVector operator-(const STVector& rhs) const;
		STVector& operator-=(const STVector& rhs);
		STVector operator*(const float s) const;
		STVector operator*(const STVector& s) const;
		STVector& operator*=(const float s);
		STVector& operator*=(const STVector& s);
		STVector operator/(const float s) const;
		STVector operator/(const STVector& s) const;
		STVector& operator/=(const float s);
		STVector& operator/=(const STVector& s);

		float Length() const;
};

STVector operator*(float lhs, const STVector &rhs);
STVector Cross(const STVector& v1, const STVector& v2);
float    Dot(const STVector& v1, const STVector& v2);
STVector Normalize(const STVector& v);



#endif // __STVECTOR_H__


