
#ifndef __ST_H__
#define __ST_H__


// not defined in math.h on windows
#ifndef M_PI
#define M_PI   3.14159265
#endif


enum STStatus {ST_OK=0, ST_ERROR}; 


/**
 *	All Objects that are to be inserted into a scene must implement
 *	the STDrawable interface
*/
class STDrawable {

	public:
		virtual void Draw() = 0;
};

// Forward declarations
class STVector;
class STColor;
class STPixel;
class STImage;
class STHDRImage;
class STShape;
class STTransform;
class STSceneNode;
class STTimer;
class STText;
class STFontFace;
class STJoystick;
class STTexture;

#include "STUtil.h"
#include "STColor.h"
#include "STVector.h"
#include "STImage.h"
#include "STHDRImage.h"
#include "STShape.h"
#include "STTransform.h"
#include "STSceneNode.h"
#include "STTimer.h"
#include "STText.h"
#include "STFontFace.h"
#include "STJoystick.h"
#include "STTexture.h"

#endif  // ST_H___
